
CODEGEN_DIR=asm

AUTOGEN_SRCS_DIR=$(CODEGEN_DIR)/auto
AUTOGEN_SRCS_POLY_TOOM4_DIR=$(AUTOGEN_SRCS_DIR)/poly/toom4
AUTOGEN_SRCS_POLY_TOOM3_DIR=$(AUTOGEN_SRCS_DIR)/poly/toom3
AUTOGEN_SRCS_POLY_SCHOOLBOOK_DIR=$(AUTOGEN_SRCS_DIR)/poly/schoolbook
AUTOGEN_SRCS_POLY_SIMD_DIR=$(AUTOGEN_SRCS_DIR)/poly/simd
AUTOGEN_SRCS_PERMUTE_DIR=$(AUTOGEN_SRCS_DIR)/permute
AUTOGEN_SRCS_TRANSPOSE_DIR=$(AUTOGEN_SRCS_DIR)/transpose
AUTOGEN_SRCS_NTT_N256_DIR=$(AUTOGEN_SRCS_DIR)/ntt_n256
AUTOGEN_SRCS_NTT_256_DIR=$(AUTOGEN_SRCS_DIR)/ntt_256
AUTOGEN_SRCS_NTT_1024_DIR=$(AUTOGEN_SRCS_DIR)/ntt_1024
AUTOGEN_SRCS_NTT_512_DIR=$(AUTOGEN_SRCS_DIR)/ntt_512
AUTOGEN_SRCS_NTT_768_DIR=$(AUTOGEN_SRCS_DIR)/ntt_768
AUTOGEN_SRCS_NTT_192_DIR=$(AUTOGEN_SRCS_DIR)/ntt_192
AUTOGEN_SRCS_NTT_384_DIR=$(AUTOGEN_SRCS_DIR)/ntt_384
AUTOGEN_SRCS_UNPACK_DIR=$(AUTOGEN_SRCS_DIR)/unpack

MANUAL_SRCS_DIR=$(CODEGEN_DIR)/manual

MANUAL_SRCS_MONTGOMERY_DIR=$(MANUAL_SRCS_DIR)/montgomery
MANUAL_SRCS_MONTGOMERY_ALL=$(wildcard $(MANUAL_SRCS_MONTGOMERY_DIR)/*.s) $(wildcard $(MANUAL_SRCS_MONTGOMERY_DIR)/*.h)

MANUAL_SRCS_NTT_KYBER_DIR=$(MANUAL_SRCS_DIR)/ntt_kyber
MANUAL_SRCS_NTT_KYBER_ALL=$(wildcard $(MANUAL_SRCS_NTT_KYBER_DIR)/*.s) $(wildcard $(MANUAL_SRCS_NTT_KYBER_DIR)/*.h)

MANUAL_SRCS_NTT_DILITHIUM_DIR=$(MANUAL_SRCS_DIR)/ntt_dilithium
MANUAL_SRCS_NTT_DILITHIUM_ALL=$(wildcard $(MANUAL_SRCS_NTT_DILITHIUM_DIR)/*.s) $(wildcard $(MANUAL_SRCS_NTT_DILITHIUM_DIR)/*.h)

MANUAL_SRCS_NTT_N256_DIR=$(MANUAL_SRCS_DIR)/ntt_n256
MANUAL_SRCS_NTT_N256_ALL=$(wildcard $(MANUAL_SRCS_NTT_N256_DIR)/*.s) $(wildcard $(MANUAL_SRCS_NTT_N256_DIR)/*.h)

MANUAL_SRCS_CRT_DIR=$(MANUAL_SRCS_DIR)/crt
MANUAL_SRCS_CRT_ALL=$(wildcard $(MANUAL_SRCS_CRT_DIR)/*.s) $(wildcard $(MANUAL_SRCS_CRT_DIR)/*.h)

MANUAL_SRCS_CT_DIR=$(MANUAL_SRCS_DIR)/ct
MANUAL_SRCS_CT_ALL=$(wildcard $(MANUAL_SRCS_CT_DIR)/*.s) $(wildcard $(MANUAL_SRCS_CT_DIR)/*.h)

MANUAL_SRCS_CHUNK_DIR=$(MANUAL_SRCS_DIR)/chunk
MANUAL_SRCS_CHUNK_ALL=$(wildcard $(MANUAL_SRCS_CHUNK_DIR)/*.s) $(wildcard $(MANUAL_SRCS_CHUNK_DIR)/*.h)

MANUAL_SRCS_KARATSUBA_DIR=$(MANUAL_SRCS_DIR)/karatsuba
MANUAL_SRCS_KARATSUBA_ALL=$(wildcard $(MANUAL_SRCS_KARATSUBA_DIR)/*.s) $(wildcard $(MANUAL_SRCS_KARATSUBA_DIR)/*.h)

MANUAL_SRCS_SCHOOLBOOK_DIR=$(MANUAL_SRCS_DIR)/schoolbook
MANUAL_SRCS_SCHOOLBOOK_ALL=$(wildcard $(MANUAL_SRCS_SCHOOLBOOK_DIR)/*.s) $(wildcard $(MANUAL_SRCS_SCHOOLBOOK_DIR)/*.h)

MANUAL_SRCS_POLY_ALL=$(MANUAL_SRCS_KARATSUBA_ALL) $(MANUAL_SRCS_MONTGOMERY_ALL) $(MANUAL_SRCS_SCHOOLBOOK_ALL)

MANUAL_SRCS_NTT_1024_ALL=$(MANUAL_SRCS_MONTGOMERY_ALL)
MANUAL_SRCS_NTT_768_ALL=$(MANUAL_SRCS_MONTGOMERY_ALL)
MANUAL_SRCS_NTT_192_ALL=$(MANUAL_SRCS_MONTGOMERY_ALL)
MANUAL_SRCS_NTT_384_ALL=$(MANUAL_SRCS_MONTGOMERY_ALL)


AUTOGEN_SRCS_ALL=$(wildcard $(AUTOGEN_SRCS_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_DIR)/*/*/*/*/*.s)
AUTOGEN_SRCS_POLY_TOOM4_ALL=$(wildcard $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_POLY_TOOM3_ALL=$(wildcard $(AUTOGEN_SRCS_POLY_TOOM3_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_TOOM3_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_TOOM3_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_TOOM3_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_POLY_SCHOOLBOOK_ALL=$(wildcard $(AUTOGEN_SRCS_POLY_SCHOOLBOOK_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_SCHOOLBOOK_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_SCHOOLBOOK_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_SCHOOLBOOK_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_POLY_SIMD_ALL=$(wildcard $(AUTOGEN_SRCS_POLY_SIMD_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_SIMD_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_SIMD_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_POLY_SIMD_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_PERMUTE_ALL=$(wildcard $(AUTOGEN_SRCS_PERMUTE_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_PERMUTE_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_PERMUTE_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_PERMUTE_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_TRANSPOSE_ALL=$(wildcard $(AUTOGEN_SRCS_TRANSPOSE_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_TRANSPOSE_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_TRANSPOSE_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_TRANSPOSE_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_NTT_N256_ALL=$(wildcard $(AUTOGEN_SRCS_NTT_N256_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_N256_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_N256_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_N256_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_NTT_256_ALL=$(wildcard $(AUTOGEN_SRCS_NTT_256_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_256_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_256_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_256_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_NTT_1024_ALL=$(wildcard $(AUTOGEN_SRCS_NTT_1024_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_1024_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_1024_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_1024_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_NTT_512_ALL=$(wildcard $(AUTOGEN_SRCS_NTT_512_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_512_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_512_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_512_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_NTT_768_ALL=$(wildcard $(AUTOGEN_SRCS_NTT_768_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_768_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_768_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_768_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_NTT_192_ALL=$(wildcard $(AUTOGEN_SRCS_NTT_192_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_192_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_192_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_192_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_NTT_384_ALL=$(wildcard $(AUTOGEN_SRCS_NTT_384_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_384_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_384_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_NTT_384_DIR)/*/*/*/*.s)
AUTOGEN_SRCS_UNPACK_ALL=$(wildcard $(AUTOGEN_SRCS_UNPACK_DIR)/*.s) $(wildcard $(AUTOGEN_SRCS_UNPACK_DIR)/*/*.s) $(wildcard $(AUTOGEN_SRCS_UNPACK_DIR)/*/*/*.s) $(wildcard $(AUTOGEN_SRCS_UNPACK_DIR)/*/*/*/*.s)

TEST_BASE_DIR=tests

TEST_POLY_SCHOOLBOOK_DIR=$(TEST_BASE_DIR)/schoolbook
TEST_POLY_SCHOOLBOOK_SOURCES_AUTO_DIR=$(TEST_POLY_SCHOOLBOOK_DIR)/auto
TEST_POLY_SCHOOLBOOK_SRC_C=$(wildcard $(TEST_POLY_SCHOOLBOOK_DIR)/*.c) $(wildcard $(TEST_POLY_SCHOOLBOOK_DIR)/*/*.c)
TEST_POLY_SCHOOLBOOK_SRC_AUTO_SCHOOLBOOK=$(patsubst $(AUTOGEN_SRCS_POLY_SCHOOLBOOK_DIR)/%.s, $(TEST_POLY_SCHOOLBOOK_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_POLY_SCHOOLBOOK_ALL))
TEST_POLY_SCHOOLBOOK_SRC_AUTO_SIMD=$(patsubst $(AUTOGEN_SRCS_POLY_SIMD_DIR)/%.s, $(TEST_POLY_SCHOOLBOOK_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_POLY_SIMD_ALL))
TEST_POLY_SCHOOLBOOK_SRC_AUTO=$(TEST_POLY_SCHOOLBOOK_SRC_AUTO_SIMD) $(TEST_POLY_SCHOOLBOOK_SRC_AUTO_SCHOOLBOOK)
TEST_POLY_SCHOOLBOOK_SRC_ALL=$(TEST_POLY_SCHOOLBOOK_SRC_C) $(TEST_POLY_SCHOOLBOOK_SRC_AUTO)

TEST_POLY_TOOM_DIR=$(TEST_BASE_DIR)/toom
TEST_POLY_TOOM_SOURCES_AUTO_DIR=$(TEST_POLY_TOOM_DIR)/auto
TEST_POLY_TOOM_SRC_C=$(wildcard $(TEST_POLY_TOOM_DIR)/*.c) $(wildcard $(TEST_POLY_TOOM_DIR)/*/*.c)
TEST_POLY_TOOM_SRC_AUTO_TOOM3=$(patsubst $(AUTOGEN_SRCS_POLY_TOOM3_DIR)/%.s, $(TEST_POLY_TOOM_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_POLY_TOOM3_ALL))
TEST_POLY_TOOM_SRC_AUTO_TOOM4=$(patsubst $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/%.s, $(TEST_POLY_TOOM_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_POLY_TOOM4_ALL))
TEST_POLY_TOOM_SRC_AUTO=$(TEST_POLY_TOOM_SRC_AUTO_TOOM3) $(TEST_POLY_TOOM_SRC_AUTO_TOOM4)
TEST_POLY_TOOM_SRC_ALL=$(TEST_POLY_TOOM_SRC_C) $(TEST_POLY_TOOM_SRC_AUTO)

TEST_PERMUTE_DIR=$(TEST_BASE_DIR)/permute
TEST_PERMUTE_SOURCES_AUTO_DIR=$(TEST_PERMUTE_DIR)/auto
TEST_PERMUTE_SRC_C=$(wildcard $(TEST_PERMUTE_DIR)/*.c) $(wildcard $(TEST_PERMUTE_DIR)/*/*.c)
TEST_PERMUTE_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_PERMUTE_DIR)/%.s, $(TEST_PERMUTE_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_PERMUTE_ALL))
TEST_PERMUTE_SRC_ALL=$(TEST_PERMUTE_SRC_C) $(TEST_PERMUTE_SRC_AUTO)

TEST_UNPACK_DIR=$(TEST_BASE_DIR)/unpack
TEST_UNPACK_SOURCES_AUTO_DIR=$(TEST_UNPACK_DIR)/auto
TEST_UNPACK_SRC_C=$(wildcard $(TEST_UNPACK_DIR)/*.c) $(wildcard $(TEST_UNPACK_DIR)/*/*.c)
TEST_UNPACK_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_UNPACK_DIR)/%.s, $(TEST_UNPACK_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_UNPACK_ALL))
TEST_UNPACK_SRC_ALL=$(TEST_UNPACK_SRC_C) $(TEST_UNPACK_SRC_AUTO)

TEST_NTT_N256_DIR=$(TEST_BASE_DIR)/ntt_n256
TEST_NTT_N256_SOURCES_AUTO_DIR=$(TEST_NTT_N256_DIR)/auto
TEST_NTT_N256_SOURCES_MANUAL_DIR=$(TEST_NTT_N256_DIR)/manual
TEST_NTT_N256_SRC_C=$(wildcard $(TEST_NTT_N256_DIR)/*.c) $(wildcard $(TEST_NTT_N256_DIR)/*/*.c)
TEST_NTT_N256_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_NTT_N256_DIR)/%.s, $(TEST_NTT_N256_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_N256_ALL))
TEST_NTT_N256_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_NTT_N256_DIR)/%.s, $(TEST_NTT_N256_SOURCES_MANUAL_DIR)/%.s, $(MANUAL_SRCS_NTT_N256_ALL))
TEST_NTT_N256_SRC_ALL=$(TEST_NTT_N256_SRC_C) $(TEST_NTT_N256_SRC_AUTO) $(TEST_NTT_N256_SRC_MANUAL)

TEST_NTT_256_DIR=$(TEST_BASE_DIR)/ntt_256
TEST_NTT_256_SOURCES_AUTO_DIR=$(TEST_NTT_256_DIR)/auto
TEST_NTT_256_SRC_C=$(wildcard $(TEST_NTT_256_DIR)/*.c) $(wildcard $(TEST_NTT_256_DIR)/*/*.c)
TEST_NTT_256_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_NTT_256_DIR)/%.s, $(TEST_NTT_256_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_256_ALL))
TEST_NTT_256_SRC_ALL=$(TEST_NTT_256_SRC_C) $(TEST_NTT_256_SRC_AUTO)

TEST_NTT_1024_DIR=$(TEST_BASE_DIR)/ntt_1024
TEST_NTT_1024_SOURCES_AUTO_DIR=$(TEST_NTT_1024_DIR)/auto
TEST_NTT_1024_SRC_C=$(wildcard $(TEST_NTT_1024_DIR)/*.c) $(wildcard $(TEST_NTT_1024_DIR)/*/*.c)
TEST_NTT_1024_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_NTT_1024_DIR)/%.s, $(TEST_NTT_1024_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_1024_ALL))
TEST_NTT_1024_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_MONTGOMERY_DIR)/%,$(TEST_NTT_1024_DIR)/%, $(MANUAL_SRCS_MONTGOMERY_ALL))
TEST_NTT_1024_SRC_ALL=$(TEST_NTT_1024_SRC_C) $(TEST_NTT_1024_SRC_AUTO) $(TEST_NTT_1024_SRC_MANUAL)

TEST_NTT_512_DIR=$(TEST_BASE_DIR)/ntt_512
TEST_NTT_512_SOURCES_AUTO_DIR=$(TEST_NTT_512_DIR)/auto
TEST_NTT_512_SRC_C=$(wildcard $(TEST_NTT_512_DIR)/*.c) $(wildcard $(TEST_NTT_512_DIR)/*/*.c)
TEST_NTT_512_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_NTT_512_DIR)/%.s, $(TEST_NTT_512_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_512_ALL))
TEST_NTT_512_SRC_ALL=$(TEST_NTT_512_SRC_C) $(TEST_NTT_512_SRC_AUTO)

TEST_NTT_768_DIR=$(TEST_BASE_DIR)/ntt_768
TEST_NTT_768_SOURCES_AUTO_DIR=$(TEST_NTT_768_DIR)/auto
TEST_NTT_768_SRC_C=$(wildcard $(TEST_NTT_768_DIR)/*.c) $(wildcard $(TEST_NTT_768_DIR)/*/*.c)
TEST_NTT_768_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_NTT_768_DIR)/%.s, $(TEST_NTT_768_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_768_ALL))
TEST_NTT_768_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_MONTGOMERY_DIR)/%,$(TEST_NTT_768_DIR)/%, $(MANUAL_SRCS_MONTGOMERY_ALL))
TEST_NTT_768_SRC_ALL=$(TEST_NTT_768_SRC_C) $(TEST_NTT_768_SRC_AUTO) $(TEST_NTT_768_SRC_MANUAL)

TEST_NTT_192_DIR=$(TEST_BASE_DIR)/ntt_192
TEST_NTT_192_SOURCES_AUTO_DIR=$(TEST_NTT_192_DIR)/auto
TEST_NTT_192_SRC_C=$(wildcard $(TEST_NTT_192_DIR)/*.c) $(wildcard $(TEST_NTT_192_DIR)/*/*.c)
TEST_NTT_192_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_NTT_192_DIR)/%.s, $(TEST_NTT_192_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_192_ALL))
TEST_NTT_192_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_MONTGOMERY_DIR)/%,$(TEST_NTT_192_DIR)/%, $(MANUAL_SRCS_MONTGOMERY_ALL))
TEST_NTT_192_SRC_ALL=$(TEST_NTT_192_SRC_C) $(TEST_NTT_192_SRC_AUTO) $(TEST_NTT_192_SRC_MANUAL)

TEST_NTT_384_DIR=$(TEST_BASE_DIR)/ntt_384
TEST_NTT_384_SOURCES_AUTO_DIR=$(TEST_NTT_384_DIR)/auto
TEST_NTT_384_SRC_C=$(wildcard $(TEST_NTT_384_DIR)/*.c) $(wildcard $(TEST_NTT_384_DIR)/*/*.c)
TEST_NTT_384_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_NTT_384_DIR)/%.s, $(TEST_NTT_384_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_384_ALL))
TEST_NTT_384_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_MONTGOMERY_DIR)/%,$(TEST_NTT_384_DIR)/%, $(MANUAL_SRCS_MONTGOMERY_ALL))
TEST_NTT_384_SRC_ALL=$(TEST_NTT_384_SRC_C) $(TEST_NTT_384_SRC_AUTO) $(TEST_NTT_384_SRC_MANUAL)

TEST_TRANSPOSE_DIR=$(TEST_BASE_DIR)/transpose
TEST_TRANSPOSE_SOURCES_AUTO_DIR=$(TEST_TRANSPOSE_DIR)/auto
TEST_TRANSPOSE_SRC_C=$(wildcard $(TEST_TRANSPOSE_DIR)/*.c) $(wildcard $(TEST_TRANSPOSE_DIR)/*/*.c)
TEST_TRANSPOSE_SRC_AUTO=$(patsubst $(AUTOGEN_SRCS_TRANSPOSE_DIR)/%.s, $(TEST_TRANSPOSE_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_TRANSPOSE_ALL))
TEST_TRANSPOSE_SRC_ALL=$(TEST_TRANSPOSE_SRC_C) $(TEST_TRANSPOSE_SRC_AUTO)

TEST_HELLOWORLD_DIR=$(TEST_BASE_DIR)/helloworld
TEST_HELLOWORLD_SOURCES_AUTO_DIR=$(TEST_HELLOWORLD_DIR)/auto
TEST_HELLOWORLD_SRC_C=$(wildcard $(TEST_HELLOWORLD_DIR)/*.c) $(wildcard $(TEST_HELLOWORLD_DIR)/*/*.c)
TEST_HELLOWORLD_SRC_ALL=$(TEST_HELLOWORLD_SRC_C)


TEST_SABER_DIR=$(TEST_BASE_DIR)/saber
TEST_SABER_SOURCES_AUTO_DIR=$(TEST_SABER_DIR)/auto
TEST_SABER_SOURCES_MANUAL_DIR=$(TEST_SABER_DIR)/manual
TEST_SABER_SRC_C=$(wildcard $(TEST_SABER_DIR)/*.c) $(wildcard $(TEST_SABER_DIR)/*/*.c)
TEST_SABER_SRC_MANUAL_KARATSUBA=$(patsubst $(MANUAL_SRCS_KARATSUBA_DIR)/%, $(TEST_SABER_SOURCES_MANUAL_DIR)/%, $(MANUAL_SRCS_KARATSUBA_ALL))
TEST_SABER_SRC_MANUAL_MONTGOMERY=$(patsubst $(MANUAL_SRCS_MONTGOMERY_DIR)/%, $(TEST_SABER_SOURCES_MANUAL_DIR)/%, $(MANUAL_SRCS_MONTGOMERY_ALL))
TEST_SABER_SRC_AUTO_TOOM4=$(patsubst $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/%.s, $(TEST_SABER_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_POLY_TOOM4_ALL))
TEST_SABER_SRC_AUTO_NTT_N256=$(patsubst $(AUTOGEN_SRCS_NTT_N256_DIR)/%.s, $(TEST_SABER_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_N256_ALL))
TEST_SABER_SRC_AUTO_SCHOOLBOOK=$(patsubst $(AUTOGEN_SRCS_POLY_SIMD_DIR)/%.s, $(TEST_SABER_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_POLY_SIMD_ALL))
TEST_SABER_SRC_ALL=$(TEST_SABER_SRC_C) $(TEST_SABER_SRC_MANUAL_MONTGOMERY) $(TEST_SABER_SRC_MANUAL_KARATSUBA) $(TEST_SABER_SRC_AUTO_TOOM4) $(TEST_SABER_SRC_AUTO_SCHOOLBOOK) $(TEST_SABER_SRC_AUTO_NTT_N256)

TEST_INTMULNTT_DIR=$(TEST_BASE_DIR)/intmulntt
TEST_INTMULNTT_SOURCES_AUTO_DIR=$(TEST_INTMULNTT_DIR)/
TEST_INTMULNTT_SOURCES_MANUAL_DIR=$(TEST_INTMULNTT_DIR)/
TEST_INTMULNTT_SRC_C=$(wildcard $(TEST_INTMULNTT_DIR)/*.c) $(wildcard $(TEST_INTMULNTT_DIR)/*/*.c)
TEST_INTMULNTT_SRC_MANUAL_MONTGOMERY=$(patsubst $(MANUAL_SRCS_MONTGOMERY_DIR)/%, $(TEST_INTMULNTT_SOURCES_MANUAL_DIR)/%, $(MANUAL_SRCS_MONTGOMERY_ALL))
TEST_INTMULNTT_SRC_MANUAL_CRT=$(patsubst $(MANUAL_SRCS_CRT_DIR)/%, $(TEST_INTMULNTT_SOURCES_MANUAL_DIR)/%, $(MANUAL_SRCS_CRT_ALL))
TEST_INTMULNTT_SRC_AUTO_NTT_384=$(patsubst $(AUTOGEN_SRCS_NTT_384_DIR)/%.s, $(TEST_INTMULNTT_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_384_ALL))
TEST_INTMULNTT_SRC_AUTO_NTT_192=$(patsubst $(AUTOGEN_SRCS_NTT_192_DIR)/%.s, $(TEST_INTMULNTT_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_192_ALL))
TEST_INTMULNTT_SRC_ALL=$(TEST_INTMULNTT_SRC_C) $(TEST_INTMULNTT_SRC_MANUAL_MONTGOMERY) $(TEST_INTMULNTT_SRC_MANUAL_CRT) $(TEST_INTMULNTT_SRC_AUTO_NTT_384) $(TEST_INTMULNTT_SRC_AUTO_NTT_192)

TEST_MONTGOMERY_DIR=$(TEST_BASE_DIR)/montgomery
TEST_MONTGOMERY_SRC_C=$(wildcard $(TEST_MONTGOMERY_DIR)/*.c) $(wildcard $(TEST_MONTGOMERY_DIR)/*/*.c) $(wildcard $(TEST_MONTGOMERY_DIR)/*.s)
TEST_MONTGOMERY_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_MONTGOMERY_DIR)/%, $(TEST_MONTGOMERY_DIR)/%, $(MANUAL_SRCS_MONTGOMERY_ALL))
TEST_MONTGOMERY_SRC_ALL=$(TEST_MONTGOMERY_SRC_C) $(TEST_MONTGOMERY_SRC_MANUAL)

TEST_NTT_KYBER_DIR=$(TEST_BASE_DIR)/ntt_kyber
TEST_NTT_KYBER_SRC_C=$(wildcard $(TEST_NTT_KYBER_DIR)/*.c) $(wildcard $(TEST_NTT_KYBER_DIR)/*/*.c) $(wildcard $(TEST_NTT_KYBER_DIR)/*.s)
TEST_NTT_KYBER_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_NTT_KYBER_DIR)/%, $(TEST_NTT_KYBER_DIR)/manual/%, $(MANUAL_SRCS_NTT_KYBER_ALL))
TEST_NTT_KYBER_SRC_ALL=$(TEST_NTT_KYBER_SRC_C) $(TEST_NTT_KYBER_SRC_MANUAL)

TEST_NTT_DILITHIUM_DIR=$(TEST_BASE_DIR)/ntt_dilithium
TEST_NTT_DILITHIUM_SRC_C=$(wildcard $(TEST_NTT_DILITHIUM_DIR)/*.c) $(wildcard $(TEST_NTT_DILITHIUM_DIR)/*/*.c) $(wildcard $(TEST_NTT_DILITHIUM_DIR)/*.s)
TEST_NTT_DILITHIUM_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_NTT_DILITHIUM_DIR)/%, $(TEST_NTT_DILITHIUM_DIR)/manual/%, $(MANUAL_SRCS_NTT_DILITHIUM_ALL))
TEST_NTT_DILITHIUM_SRC_ALL=$(TEST_NTT_DILITHIUM_SRC_C) $(TEST_NTT_DILITHIUM_SRC_MANUAL)

TEST_CRT_DIR=$(TEST_BASE_DIR)/crt
TEST_CRT_SRC_C=$(wildcard $(TEST_CRT_DIR)/*.c) $(wildcard $(TEST_CRT_DIR)/*/*.c) $(wildcard $(TEST_CRT_DIR)/*.s)
TEST_CRT_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_CRT_DIR)/%, $(TEST_CRT_DIR)/%, $(MANUAL_SRCS_CRT_ALL))
TEST_CRT_SRC_ALL=$(TEST_CRT_SRC_C) $(TEST_CRT_SRC_MANUAL)

TEST_CT_DIR=$(TEST_BASE_DIR)/ct
TEST_CT_SRC_C=$(wildcard $(TEST_CT_DIR)/*.c) $(wildcard $(TEST_CT_DIR)/*/*.c) $(wildcard $(TEST_CT_DIR)/*.s)
TEST_CT_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_CT_DIR)/%, $(TEST_CT_DIR)/%, $(MANUAL_SRCS_CT_ALL))
TEST_CT_SRC_ALL=$(TEST_CT_SRC_C) $(TEST_CT_SRC_MANUAL)


TEST_CHUNK_DIR=$(TEST_BASE_DIR)/chunk
TEST_CHUNK_SRC_C=$(wildcard $(TEST_CHUNK_DIR)/*.c) $(wildcard $(TEST_CHUNK_DIR)/*/*.c) $(wildcard $(TEST_CHUNK_DIR)/*.s)
TEST_CHUNK_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_CHUNK_DIR)/%, $(TEST_CHUNK_DIR)/%, $(MANUAL_SRCS_CHUNK_ALL))
TEST_CHUNK_SRC_ALL=$(TEST_CHUNK_SRC_C) $(TEST_CHUNK_SRC_MANUAL)

TEST_KARATSUBA_DIR=$(TEST_BASE_DIR)/karatsuba
TEST_KARATSUBA_SRC_C=$(wildcard $(TEST_KARATSUBA_DIR)/*.c) $(wildcard $(TEST_KARATSUBA_DIR)/*/*.c) $(wildcard $(TEST_KARATSUBA_DIR)/*.s)
TEST_KARATSUBA_SRC_MANUAL=$(patsubst $(MANUAL_SRCS_KARATSUBA_DIR)/%, $(TEST_KARATSUBA_DIR)/%, $(MANUAL_SRCS_KARATSUBA_ALL))
TEST_KARATSUBA_SRC_ALL=$(TEST_KARATSUBA_SRC_C) $(TEST_KARATSUBA_SRC_MANUAL)


TEST_POLY_DIR=$(TEST_BASE_DIR)/poly
TEST_POLY_SOURCES_AUTO_DIR=$(TEST_POLY_DIR)/auto
TEST_POLY_SOURCES_MANUAL_DIR=$(TEST_POLY_DIR)/manual
TEST_POLY_SRC_C=$(wildcard $(TEST_POLY_DIR)/*.c) $(wildcard $(TEST_POLY_DIR)/*/*.c) $(wildcard $(TEST_POLY_DIR)/*.s)
TEST_POLY_SRC_MANUAL_KARATSUBA=$(patsubst $(MANUAL_SRCS_KARATSUBA_DIR)/%, $(TEST_POLY_SOURCES_MANUAL_DIR)/%, $(MANUAL_SRCS_KARATSUBA_ALL))
TEST_POLY_SRC_MANUAL_SCHOOLBOOK=$(patsubst $(MANUAL_SRCS_SCHOOLBOOK_DIR)/%, $(TEST_POLY_SOURCES_MANUAL_DIR)/%, $(MANUAL_SRCS_SCHOOLBOOK_ALL))
TEST_POLY_SRC_MANUAL_MONTGOMERY=$(patsubst $(MANUAL_SRCS_MONTGOMERY_DIR)/%, $(TEST_POLY_SOURCES_MANUAL_DIR)/%, $(MANUAL_SRCS_MONTGOMERY_ALL))
TEST_POLY_SRC_AUTO_TOOM4=$(patsubst $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/%.s, $(TEST_POLY_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_POLY_TOOM4_ALL))
TEST_POLY_SRC_AUTO_NTT_N256=$(patsubst $(AUTOGEN_SRCS_NTT_N256_DIR)/%.s, $(TEST_POLY_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_NTT_N256_ALL))
TEST_POLY_SRC_AUTO_SCHOOLBOOK=$(patsubst $(AUTOGEN_SRCS_POLY_SIMD_DIR)/%.s, $(TEST_POLY_SOURCES_AUTO_DIR)/%.s, $(AUTOGEN_SRCS_POLY_SIMD_ALL))
TEST_POLY_SRC_ALL=$(TEST_POLY_SRC_C) $(TEST_POLY_SRC_MANUAL_MONTGOMERY) $(TEST_POLY_SRC_MANUAL_SCHOOLBOOK) $(TEST_POLY_SRC_MANUAL_KARATSUBA) $(TEST_POLY_SRC_AUTO_TOOM4) $(TEST_POLY_SRC_AUTO_SCHOOLBOOK) $(TEST_POLY_SRC_AUTO_NTT_N256) $(TEST_POLY_SRC_AUTO_MONTGOMERY)

TEST_SRC_AUTO_ALL=$(TEST_POLY_SCHOOLBOOK_SRC_AUTO) $(TEST_POLY_TOOM_SRC_AUTO) $(TEST_PERMUTE_SRC_AUTO) $(TEST_UNPACK_SRC_AUTO) $(TEST_TRANSPOSE_SRC_AUTO) $(TEST_HELLOWORLD_SRC_AUTO) $(TEST_NTT_N256_SRC_AUTO) $(TEST_POLY_SRC_AUTO_ALL) $(TEST_SABER_SRC_AUTO)

TEST_ENVS_BASE_DIR=envs
TEST_ENV_M55_MPS3_FVP_BASE=$(TEST_ENVS_BASE_DIR)/fvp-corstone300-mps3
TEST_ENV_M55_MPS3_FVP_SRC=$(TEST_ENV_M55_MPS3_FVP_BASE)/src
TEST_ENV_M55_MPS3_FVP_SYMLINK=$(TEST_ENV_M55_MPS3_FVP_SRC)/test_src

TEST_ENV_M55_MPS2_FVP_BASE=$(TEST_ENVS_BASE_DIR)/fvp-corstone300-mps2
TEST_ENV_M55_MPS2_FVP_SRC=$(TEST_ENV_M55_MPS2_FVP_BASE)/src
TEST_ENV_M55_MPS2_FVP_SYMLINK=$(TEST_ENV_M55_MPS2_FVP_SRC)/test_src

TEST_ENV_M55_CORE_BASE=$(TEST_ENVS_BASE_DIR)/core
TEST_ENV_M55_CORE_SRC=$(TEST_ENV_M55_CORE_BASE)/src
TEST_ENV_M55_CORE_SYMLINK=$(TEST_ENV_M55_CORE_SRC)/test_src

PYTHON_SRCS=$(wildcard $(CODEGEN_DIR)/*.py) $(wildcard $(CODEGEN_DIR)/*/*.py) $(wildcard $(CODEGEN_DIR)/*/*/*.py) $(wildcard $(CODEGEN_DIR)/*/*/*/*/*.py)

.PHONY: all
all: codegen $(TEST_SRC_AUTO_ALL)

.PHONY: clean

ifndef PQMX_STATIC_BUILD
clean:
	make clean -C $(TEST_ENV_M55_MPS3_FVP_BASE)
	make clean -C $(TEST_ENV_M55_MPS2_FVP_BASE)
	make clean -C $(TEST_ENV_M55_CORE_BASE)
	rm -f $(TEST_SRC_AUTO_ALL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
else
clean:
	make clean -C $(TEST_ENV_M55_MPS3_FVP_BASE)
	make clean -C $(TEST_ENV_M55_MPS2_FVP_BASE)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
endif

.PHONY: cleanasm
cleanasm:
	make clean -C $(CODEGEN_DIR)

.PHONY: cleanall
cleanall: clean cleanasm

ifndef PQMX_STATIC_BUILD

$(AUTOGEN_SRCS_ALL): $(PYTHON_SRCS)
	make -C $(CODEGEN_DIR)

$(TEST_POLY_SCHOOLBOOK_SRC_AUTO_SCHOOLBOOK): $(TEST_POLY_SCHOOLBOOK_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_POLY_SCHOOLBOOK_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_POLY_SCHOOLBOOK_SRC_AUTO_SIMD): $(TEST_POLY_SCHOOLBOOK_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_POLY_SIMD_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_POLY_TOOM_SRC_AUTO_TOOM3): $(TEST_POLY_TOOM_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_POLY_TOOM3_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_POLY_TOOM_SRC_AUTO_TOOM4): $(TEST_POLY_TOOM_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_PERMUTE_SRC_AUTO): $(TEST_PERMUTE_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_PERMUTE_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_UNPACK_SRC_AUTO): $(TEST_UNPACK_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_UNPACK_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_TRANSPOSE_SRC_AUTO): $(TEST_TRANSPOSE_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_TRANSPOSE_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_N256_SRC_AUTO): $(TEST_NTT_N256_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_N256_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_256_SRC_AUTO): $(TEST_NTT_256_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_256_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_1024_SRC_AUTO): $(TEST_NTT_1024_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_1024_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_NTT_1024_SRC_MANUAL): $(TEST_NTT_1024_DIR)/%: $(MANUAL_SRCS_MONTGOMERY_DIR)/%
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_512_SRC_AUTO): $(TEST_NTT_512_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_512_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_768_SRC_AUTO): $(TEST_NTT_768_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_768_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_NTT_768_SRC_MANUAL): $(TEST_NTT_768_DIR)/%: $(MANUAL_SRCS_MONTGOMERY_DIR)/%
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_192_SRC_AUTO): $(TEST_NTT_192_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_192_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_NTT_192_SRC_MANUAL): $(TEST_NTT_192_DIR)/%: $(MANUAL_SRCS_MONTGOMERY_DIR)/%
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_384_SRC_AUTO): $(TEST_NTT_384_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_384_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_NTT_384_SRC_MANUAL): $(TEST_NTT_384_DIR)/%: $(MANUAL_SRCS_MONTGOMERY_DIR)/%
	mkdir -p $(@D)
	cp $< $@

$(TEST_MONTGOMERY_SRC_MANUAL): $(TEST_MONTGOMERY_DIR)/%.s: $(MANUAL_SRCS_MONTGOMERY_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_MONTGOMERY_SRC_MANUAL): $(TEST_MONTGOMERY_DIR)/%.h: $(MANUAL_SRCS_MONTGOMERY_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_KYBER_SRC_MANUAL): $(TEST_NTT_KYBER_DIR)/manual/%.s: $(MANUAL_SRCS_NTT_KYBER_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_NTT_KYBER_SRC_MANUAL): $(TEST_NTT_KYBER_DIR)/manual/%.h: $(MANUAL_SRCS_NTT_KYBER_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_DILITHIUM_SRC_MANUAL): $(TEST_NTT_DILITHIUM_DIR)/manual/%.s: $(MANUAL_SRCS_NTT_DILITHIUM_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_NTT_DILITHIUM_SRC_MANUAL): $(TEST_NTT_DILITHIUM_DIR)/manual/%.h: $(MANUAL_SRCS_NTT_DILITHIUM_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

$(TEST_NTT_N256_SRC_MANUAL): $(TEST_NTT_N256_DIR)/manual/%.s: $(MANUAL_SRCS_NTT_N256_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_NTT_N256_SRC_MANUAL): $(TEST_NTT_N256_DIR)/manual/%.h: $(MANUAL_SRCS_NTT_N256_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

$(TEST_CRT_SRC_MANUAL): $(TEST_CRT_DIR)/%.s: $(MANUAL_SRCS_CRT_DIR)/%.s
	mkdir -p $(@D)
	echo "A $< B $@"
	cp $< $@
$(TEST_CRT_SRC_MANUAL): $(TEST_CRT_DIR)/%.h: $(MANUAL_SRCS_CRT_DIR)/%.h
	mkdir -p $(@D)
	echo "A $< B $@"
	cp $< $@

$(TEST_CT_SRC_MANUAL): $(TEST_CT_DIR)/%.s: $(MANUAL_SRCS_CT_DIR)/%.s
	mkdir -p $(@D)
	echo "A $< B $@"
	cp $< $@
$(TEST_CT_SRC_MANUAL): $(TEST_CT_DIR)/%.h: $(MANUAL_SRCS_CT_DIR)/%.h
	mkdir -p $(@D)
	echo "A $< B $@"
	cp $< $@

$(TEST_CHUNK_SRC_MANUAL): $(TEST_CHUNK_DIR)/%.s: $(MANUAL_SRCS_CHUNK_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_CHUNK_SRC_MANUAL): $(TEST_CHUNK_DIR)/%.h: $(MANUAL_SRCS_CHUNK_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

$(TEST_KARATSUBA_SRC_MANUAL): $(TEST_KARATSUBA_DIR)/%.s: $(MANUAL_SRCS_KARATSUBA_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_KARATSUBA_SRC_MANUAL): $(TEST_KARATSUBA_DIR)/%.h: $(MANUAL_SRCS_KARATSUBA_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

$(TEST_POLY_SRC_AUTO_TOOM4): $(TEST_POLY_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_POLY_SRC_AUTO_NTT_N256): $(TEST_POLY_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_N256_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_POLY_SRC_AUTO_SCHOOLBOOK): $(TEST_POLY_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_POLY_SIMD_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_POLY_SRC_MANUAL_KARATSUBA): $(TEST_POLY_SOURCES_MANUAL_DIR)/%.s: $(MANUAL_SRCS_KARATSUBA_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_POLY_SRC_MANUAL_KARATSUBA): $(TEST_POLY_SOURCES_MANUAL_DIR)/%.h: $(MANUAL_SRCS_KARATSUBA_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@
$(TEST_POLY_SRC_MANUAL_SCHOOLBOOK): $(TEST_POLY_SOURCES_MANUAL_DIR)/%.s: $(MANUAL_SRCS_SCHOOLBOOK_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_POLY_SRC_MANUAL_SCHOOLBOOK): $(TEST_POLY_SOURCES_MANUAL_DIR)/%.h: $(MANUAL_SRCS_SCHOOLBOOK_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@
$(TEST_POLY_SRC_MANUAL_MONTGOMERY): $(TEST_POLY_SOURCES_MANUAL_DIR)/%.s: $(MANUAL_SRCS_MONTGOMERY_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_POLY_SRC_MANUAL_MONTGOMERY): $(TEST_POLY_SOURCES_MANUAL_DIR)/%.h: $(MANUAL_SRCS_MONTGOMERY_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

$(TEST_SABER_SRC_AUTO_TOOM4): $(TEST_SABER_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_POLY_TOOM4_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_SABER_SRC_AUTO_NTT_N256): $(TEST_SABER_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_N256_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_SABER_SRC_AUTO_SCHOOLBOOK): $(TEST_SABER_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_POLY_SIMD_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_SABER_SRC_MANUAL_KARATSUBA): $(TEST_SABER_SOURCES_MANUAL_DIR)/%.s: $(MANUAL_SRCS_KARATSUBA_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_SABER_SRC_MANUAL_KARATSUBA): $(TEST_SABER_SOURCES_MANUAL_DIR)/%.h: $(MANUAL_SRCS_KARATSUBA_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@
$(TEST_SABER_SRC_MANUAL_MONTGOMERY): $(TEST_SABER_SOURCES_MANUAL_DIR)/%.s: $(MANUAL_SRCS_MONTGOMERY_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_SABER_SRC_MANUAL_MONTGOMERY): $(TEST_SABER_SOURCES_MANUAL_DIR)/%.h: $(MANUAL_SRCS_MONTGOMERY_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

$(TEST_INTMULNTT_SRC_AUTO_NTT_384): $(TEST_INTMULNTT_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_384_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_INTMULNTT_SRC_AUTO_NTT_384): $(TEST_INTMULNTT_SOURCES_AUTO_DIR)/%.h: $(AUTOGEN_SRCS_NTT_384_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@
$(TEST_INTMULNTT_SRC_AUTO_NTT_192): $(TEST_INTMULNTT_SOURCES_AUTO_DIR)/%.s: $(AUTOGEN_SRCS_NTT_192_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_INTMULNTT_SRC_AUTO_NTT_192): $(TEST_INTMULNTT_SOURCES_AUTO_DIR)/%.h: $(AUTOGEN_SRCS_NTT_192_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@
$(TEST_INTMULNTT_SRC_MANUAL_CRT): $(TEST_INTMULNTT_SOURCES_MANUAL_DIR)/%.s: $(MANUAL_SRCS_CRT_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_INTMULNTT_SRC_MANUAL_CRT): $(TEST_INTMULNTT_SOURCES_MANUAL_DIR)/%.h: $(MANUAL_SRCS_CRT_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@
$(TEST_INTMULNTT_SRC_MANUAL_MONTGOMERY): $(TEST_INTMULNTT_SOURCES_MANUAL_DIR)/%.s: $(MANUAL_SRCS_MONTGOMERY_DIR)/%.s
	mkdir -p $(@D)
	cp $< $@
$(TEST_INTMULNTT_SRC_MANUAL_MONTGOMERY): $(TEST_INTMULNTT_SOURCES_MANUAL_DIR)/%.h: $(MANUAL_SRCS_MONTGOMERY_DIR)/%.h
	mkdir -p $(@D)
	cp $< $@

endif

.PHONY: codegen
codegen:
	make codegen -C $(CODEGEN_DIR)

###
### M55-MPS3-FVP test environment
###

# Toom test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_TOOM = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_toom
$(TEST_ENV_M55_MPS3_FVP_LINK_TOOM): $(TEST_POLY_TOOM_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_POLY_TOOM_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-toom
build-m55-mps3-fvp-toom: $(TEST_ENV_M55_MPS3_FVP_LINK_TOOM)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-toom
run-m55-mps3-fvp-toom: $(TEST_ENV_M55_MPS3_FVP_LINK_TOOM)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-toom
debug-m55-mps3-fvp-toom: $(TEST_ENV_M55_MPS3_FVP_LINK_TOOM)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Schoolbook test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_SCHOOLBOOK = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_schoolbook
$(TEST_ENV_M55_MPS3_FVP_LINK_SCHOOLBOOK): $(TEST_POLY_SCHOOLBOOK_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_POLY_SCHOOLBOOK_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-schoolbook
build-m55-mps3-fvp-schoolbook: $(TEST_ENV_M55_MPS3_FVP_LINK_SCHOOLBOOK)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-schoolbook
run-m55-mps3-fvp-schoolbook: $(TEST_ENV_M55_MPS3_FVP_LINK_SCHOOLBOOK)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-schoolbook
debug-m55-mps3-fvp-schoolbook: $(TEST_ENV_M55_MPS3_FVP_LINK_SCHOOLBOOK)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Permute test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_PERMUTE = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_permute
$(TEST_ENV_M55_MPS3_FVP_LINK_PERMUTE): $(TEST_PERMUTE_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_PERMUTE_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-permute
build-m55-mps3-fvp-permute: $(TEST_ENV_M55_MPS3_FVP_LINK_PERMUTE)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-permute
run-m55-mps3-fvp-permute: $(TEST_ENV_M55_MPS3_FVP_LINK_PERMUTE)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-permute
debug-m55-mps3-fvp-permute: $(TEST_ENV_M55_MPS3_FVP_LINK_PERMUTE)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Unpack test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_UNPACK = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_unpack
$(TEST_ENV_M55_MPS3_FVP_LINK_UNPACK): $(TEST_UNPACK_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_UNPACK_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-unpack
build-m55-mps3-fvp-unpack: $(TEST_ENV_M55_MPS3_FVP_LINK_UNPACK)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-unpack
run-m55-mps3-fvp-unpack: $(TEST_ENV_M55_MPS3_FVP_LINK_UNPACK)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-unpack
debug-m55-mps3-fvp-unpack: $(TEST_ENV_M55_MPS3_FVP_LINK_UNPACK)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Transpose test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_TRANSPOSE = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_transpose
$(TEST_ENV_M55_MPS3_FVP_LINK_TRANSPOSE): $(TEST_TRANSPOSE_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_TRANSPOSE_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-transpose
build-m55-mps3-fvp-transpose: $(TEST_ENV_M55_MPS3_FVP_LINK_TRANSPOSE)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-transpose
run-m55-mps3-fvp-transpose: $(TEST_ENV_M55_MPS3_FVP_LINK_TRANSPOSE)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-transpose
debug-m55-mps3-fvp-transpose: $(TEST_ENV_M55_MPS3_FVP_LINK_TRANSPOSE)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_N256 test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_N256 = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_n256
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_N256): $(TEST_NTT_N256_SRC_AUTO) $(TEST_NTT_N256_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_N256_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_n256
build-m55-mps3-fvp-ntt_n256: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_N256)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_n256
run-m55-mps3-fvp-ntt_n256: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_N256)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_n256
debug-m55-mps3-fvp-ntt_n256: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_N256)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_256 test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_256 = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_256
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_256): $(TEST_NTT_256_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_256_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_256
build-m55-mps3-fvp-ntt_256: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_256)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_256
run-m55-mps3-fvp-ntt_256: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_256)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_256
debug-m55-mps3-fvp-ntt_256: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_256)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_1024 test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_1024 = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_1024
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_1024): $(TEST_NTT_1024_SRC_AUTO) $(TEST_NTT_1024_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_1024_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_1024
build-m55-mps3-fvp-ntt_1024: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_1024)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_1024
run-m55-mps3-fvp-ntt_1024: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_1024)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_1024
debug-m55-mps3-fvp-ntt_1024: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_1024)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_512 test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_512 = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_512
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_512): $(TEST_NTT_512_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_512_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_512
build-m55-mps3-fvp-ntt_512: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_512)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_512
run-m55-mps3-fvp-ntt_512: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_512)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_512
debug-m55-mps3-fvp-ntt_512: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_512)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_768 test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_768 = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_768
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_768): $(TEST_NTT_768_SRC_AUTO) $(TEST_NTT_768_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_768_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_768
build-m55-mps3-fvp-ntt_768: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_768)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_768
run-m55-mps3-fvp-ntt_768: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_768)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_768
debug-m55-mps3-fvp-ntt_768: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_768)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_192 test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_192 = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_192
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_192): $(TEST_NTT_192_SRC_AUTO) $(TEST_NTT_192_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_192_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_192
build-m55-mps3-fvp-ntt_192: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_192)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_192
run-m55-mps3-fvp-ntt_192: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_192)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_192
debug-m55-mps3-fvp-ntt_192: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_192)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_384 test on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_384 = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_384
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_384): $(TEST_NTT_384_SRC_AUTO) $(TEST_NTT_384_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_384_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_384
build-m55-mps3-fvp-ntt_384: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_384)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_384
run-m55-mps3-fvp-ntt_384: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_384)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_384
debug-m55-mps3-fvp-ntt_384: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_384)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Montgomery multiplication on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_MONTGOMERY = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_montgomery
$(TEST_ENV_M55_MPS3_FVP_LINK_MONTGOMERY): $(TEST_MONTGOMERY_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_MONTGOMERY_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-montgomery
build-m55-mps3-fvp-montgomery: $(TEST_ENV_M55_MPS3_FVP_LINK_MONTGOMERY)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-montgomery
run-m55-mps3-fvp-montgomery: $(TEST_ENV_M55_MPS3_FVP_LINK_MONTGOMERY)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-montgomery
debug-m55-mps3-fvp-montgomery: $(TEST_ENV_M55_MPS3_FVP_LINK_MONTGOMERY)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_KYBER on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_KYBER = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_kyber
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_KYBER): $(TEST_NTT_KYBER_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_KYBER_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_kyber
build-m55-mps3-fvp-ntt_kyber: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_KYBER)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_kyber
run-m55-mps3-fvp-ntt_kyber: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_KYBER)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_kyber
debug-m55-mps3-fvp-ntt_kyber: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_KYBER)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_DILITHIUM on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_NTT_DILITHIUM = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ntt_dilithium
$(TEST_ENV_M55_MPS3_FVP_LINK_NTT_DILITHIUM): $(TEST_NTT_DILITHIUM_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_DILITHIUM_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ntt_dilithium
build-m55-mps3-fvp-ntt_dilithium: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_DILITHIUM)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ntt_dilithium
run-m55-mps3-fvp-ntt_dilithium: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_DILITHIUM)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ntt_dilithium
debug-m55-mps3-fvp-ntt_dilithium: $(TEST_ENV_M55_MPS3_FVP_LINK_NTT_DILITHIUM)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# NTT_KYBER on M55-CORE

TEST_ENV_M55_CORE_LINK_NTT_KYBER = $(TEST_ENV_M55_CORE_BASE)/test_loaded_ntt_kyber
$(TEST_ENV_M55_CORE_LINK_NTT_KYBER): $(TEST_NTT_KYBER_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_NTT_KYBER_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-ntt_kyber
build-m55-core-ntt_kyber: $(TEST_ENV_M55_CORE_LINK_NTT_KYBER)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

.PHONY: run-m55-core-ntt_kyber
run-m55-core-ntt_kyber: $(TEST_ENV_M55_CORE_LINK_NTT_KYBER)
	make run -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

.PHONY: debug-m55-core-ntt_kyber
debug-m55-core-ntt_kyber: $(TEST_ENV_M55_CORE_LINK_NTT_KYBER)
	make debug -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# NTT_DILITHIUM on M55-CORE

TEST_ENV_M55_CORE_LINK_NTT_DILITHIUM = $(TEST_ENV_M55_CORE_BASE)/test_loaded_ntt_dilithium
$(TEST_ENV_M55_CORE_LINK_NTT_DILITHIUM): $(TEST_NTT_DILITHIUM_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_NTT_DILITHIUM_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-ntt_dilithium
build-m55-core-ntt_dilithium: $(TEST_ENV_M55_CORE_LINK_NTT_DILITHIUM)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

.PHONY: run-m55-core-ntt_dilithium
run-m55-core-ntt_dilithium: $(TEST_ENV_M55_CORE_LINK_NTT_DILITHIUM)
	make run -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

.PHONY: debug-m55-core-ntt_dilithium
debug-m55-core-ntt_dilithium: $(TEST_ENV_M55_CORE_LINK_NTT_DILITHIUM)
	make debug -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# CRT on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_CRT = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_crt
$(TEST_ENV_M55_MPS3_FVP_LINK_CRT): $(TEST_CRT_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_CRT_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-crt
build-m55-mps3-fvp-crt: $(TEST_ENV_M55_MPS3_FVP_LINK_CRT)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-crt
run-m55-mps3-fvp-crt: $(TEST_ENV_M55_MPS3_FVP_LINK_CRT)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-crt
debug-m55-mps3-fvp-crt: $(TEST_ENV_M55_MPS3_FVP_LINK_CRT)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# CT on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_CT = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_ct
$(TEST_ENV_M55_MPS3_FVP_LINK_CT): $(TEST_CT_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_CT_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-ct
build-m55-mps3-fvp-ct: $(TEST_ENV_M55_MPS3_FVP_LINK_CT)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-ct
run-m55-mps3-fvp-ct: $(TEST_ENV_M55_MPS3_FVP_LINK_CT)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-ct
debug-m55-mps3-fvp-ct: $(TEST_ENV_M55_MPS3_FVP_LINK_CT)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Chunk on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_CHUNK = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_chunk
$(TEST_ENV_M55_MPS3_FVP_LINK_CHUNK): $(TEST_CHUNK_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_CHUNK_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-chunk
build-m55-mps3-fvp-chunk: $(TEST_ENV_M55_MPS3_FVP_LINK_CHUNK)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-chunk
run-m55-mps3-fvp-chunk: $(TEST_ENV_M55_MPS3_FVP_LINK_CHUNK)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-chunk
debug-m55-mps3-fvp-chunk: $(TEST_ENV_M55_MPS3_FVP_LINK_CHUNK)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Karatsuba multiplication on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_KARATSUBA = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_karatsuba
$(TEST_ENV_M55_MPS3_FVP_LINK_KARATSUBA): $(TEST_KARATSUBA_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_KARATSUBA_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-karatsuba
build-m55-mps3-fvp-karatsuba: $(TEST_ENV_M55_MPS3_FVP_LINK_KARATSUBA)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-karatsuba
run-m55-mps3-fvp-karatsuba: $(TEST_ENV_M55_MPS3_FVP_LINK_KARATSUBA)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-karatsuba
debug-m55-mps3-fvp-karatsuba: $(TEST_ENV_M55_MPS3_FVP_LINK_KARATSUBA)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Poly multiplication on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_POLY = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_poly
$(TEST_ENV_M55_MPS3_FVP_LINK_POLY): $(TEST_POLY_SRC_MANUAL_KARATSUBA) $(TEST_POLY_SRC_MANUAL_SCHOOLBOOK) $(TEST_POLY_SRC_MANUAL_MONTGOMERY) $(TEST_POLY_SRC_AUTO_TOOM4) $(TEST_POLY_SRC_AUTO_SCHOOLBOOK) $(TEST_POLY_SRC_AUTO_NTT_N256)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_POLY_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-poly
build-m55-mps3-fvp-poly: $(TEST_ENV_M55_MPS3_FVP_LINK_POLY)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-poly
run-m55-mps3-fvp-poly: $(TEST_ENV_M55_MPS3_FVP_LINK_POLY)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-poly
debug-m55-mps3-fvp-poly: $(TEST_ENV_M55_MPS3_FVP_LINK_POLY)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Saber on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_SABER = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_saber
$(TEST_ENV_M55_MPS3_FVP_LINK_SABER): $(TEST_SABER_SRC_MANUAL_KARATSUBA) $(TEST_SABER_SRC_MANUAL_MONTGOMERY) $(TEST_SABER_SRC_AUTO_TOOM4) $(TEST_SABER_SRC_AUTO_SCHOOLBOOK) $(TEST_SABER_SRC_AUTO_NTT_N256)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_SABER_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@


.PHONY: build-m55-mps3-fvp-saber
build-m55-mps3-fvp-saber: $(TEST_ENV_M55_MPS3_FVP_LINK_SABER)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-saber
run-m55-mps3-fvp-saber: $(TEST_ENV_M55_MPS3_FVP_LINK_SABER)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-saber
debug-m55-mps3-fvp-saber: $(TEST_ENV_M55_MPS3_FVP_LINK_SABER)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Intmulntt on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_INTMULNTT = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_intmulntt
$(TEST_ENV_M55_MPS3_FVP_LINK_INTMULNTT): $(TEST_INTMULNTT_SRC_MANUAL_MONTGOMERY) $(TEST_INTMULNTT_SRC_MANUAL_CRT) $(TEST_INTMULNTT_SRC_AUTO_NTT_384) $(TEST_INTMULNTT_SRC_AUTO_NTT_192)
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_INTMULNTT_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@


.PHONY: build-m55-mps3-fvp-intmulntt
build-m55-mps3-fvp-intmulntt: $(TEST_ENV_M55_MPS3_FVP_LINK_INTMULNTT)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-intmulntt
run-m55-mps3-fvp-intmulntt: $(TEST_ENV_M55_MPS3_FVP_LINK_INTMULNTT)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-intmulntt
debug-m55-mps3-fvp-intmulntt: $(TEST_ENV_M55_MPS3_FVP_LINK_INTMULNTT)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

# Template on M55-MPS3-FVP

TEST_ENV_M55_MPS3_FVP_LINK_HELLOWORLD = $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_helloworld
$(TEST_ENV_M55_MPS3_FVP_LINK_HELLOWORLD):
	rm -f $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	ln -s ../../../$(TEST_HELLOWORLD_DIR) $(TEST_ENV_M55_MPS3_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS3_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps3-fvp-helloworld
build-m55-mps3-fvp-helloworld: $(TEST_ENV_M55_MPS3_FVP_LINK_HELLOWORLD)
	make -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps3-fvp-helloworld
run-m55-mps3-fvp-helloworld: $(TEST_ENV_M55_MPS3_FVP_LINK_HELLOWORLD)
	make run -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps3-fvp-helloworld
debug-m55-mps3-fvp-helloworld: $(TEST_ENV_M55_MPS3_FVP_LINK_HELLOWORLD)
	make debug -C $(TEST_ENV_M55_MPS3_FVP_BASE) -j$(nproc)

###
### M55-MPS2-FVP test environment
###

# Toom test on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_TOOM = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_toom
$(TEST_ENV_M55_MPS2_FVP_LINK_TOOM): $(TEST_POLY_TOOM_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_POLY_TOOM_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-toom
build-m55-mps2-fvp-toom: $(TEST_ENV_M55_MPS2_FVP_LINK_TOOM)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-toom
run-m55-mps2-fvp-toom: $(TEST_ENV_M55_MPS2_FVP_LINK_TOOM)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-toom
debug-m55-mps2-fvp-toom: $(TEST_ENV_M55_MPS2_FVP_LINK_TOOM)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# Schoolbook test on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_SCHOOLBOOK = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_schoolbook
$(TEST_ENV_M55_MPS2_FVP_LINK_SCHOOLBOOK): $(TEST_POLY_SCHOOLBOOK_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_POLY_SCHOOLBOOK_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-schoolbook
build-m55-mps2-fvp-schoolbook: $(TEST_ENV_M55_MPS2_FVP_LINK_SCHOOLBOOK)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-schoolbook
run-m55-mps2-fvp-schoolbook: $(TEST_ENV_M55_MPS2_FVP_LINK_SCHOOLBOOK)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-schoolbook
debug-m55-mps2-fvp-schoolbook: $(TEST_ENV_M55_MPS2_FVP_LINK_SCHOOLBOOK)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# Permute test on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_PERMUTE = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_permute
$(TEST_ENV_M55_MPS2_FVP_LINK_PERMUTE): $(TEST_PERMUTE_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_PERMUTE_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-permute
build-m55-mps2-fvp-permute: $(TEST_ENV_M55_MPS2_FVP_LINK_PERMUTE)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-permute
run-m55-mps2-fvp-permute: $(TEST_ENV_M55_MPS2_FVP_LINK_PERMUTE)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-permute
debug-m55-mps2-fvp-permute: $(TEST_ENV_M55_MPS2_FVP_LINK_PERMUTE)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# Transpose test on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_TRANSPOSE = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_transpose
$(TEST_ENV_M55_MPS2_FVP_LINK_TRANSPOSE): $(TEST_TRANSPOSE_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_TRANSPOSE_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-transpose
build-m55-mps2-fvp-transpose: $(TEST_ENV_M55_MPS2_FVP_LINK_TRANSPOSE)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-transpose
run-m55-mps2-fvp-transpose: $(TEST_ENV_M55_MPS2_FVP_LINK_TRANSPOSE)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-transpose
debug-m55-mps2-fvp-transpose: $(TEST_ENV_M55_MPS2_FVP_LINK_TRANSPOSE)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# NTT_N256 test on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_NTT_N256 = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_ntt_n256
$(TEST_ENV_M55_MPS2_FVP_LINK_NTT_N256): $(TEST_NTT_N256_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_N256_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-ntt_n256
build-m55-mps2-fvp-ntt_n256: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_N256)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-ntt_n256
run-m55-mps2-fvp-ntt_n256: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_N256)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-ntt_n256
debug-m55-mps2-fvp-ntt_n256: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_N256)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# NTT_256 test on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_NTT_256 = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_ntt_256
$(TEST_ENV_M55_MPS2_FVP_LINK_NTT_256): $(TEST_NTT_256_SRC_AUTO)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_256_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-ntt_256
build-m55-mps2-fvp-ntt_256: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_256)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-ntt_256
run-m55-mps2-fvp-ntt_256: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_256)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-ntt_256
debug-m55-mps2-fvp-ntt_256: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_256)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# NTT_1024 test on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_NTT_1024 = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_ntt_1024
$(TEST_ENV_M55_MPS2_FVP_LINK_NTT_1024): $(TEST_NTT_1024_SRC_AUTO) $(TEST_NTT_1024_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_NTT_1024_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-ntt_1024
build-m55-mps2-fvp-ntt_1024: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_1024)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-ntt_1024
run-m55-mps2-fvp-ntt_1024: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_1024)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-ntt_1024
debug-m55-mps2-fvp-ntt_1024: $(TEST_ENV_M55_MPS2_FVP_LINK_NTT_1024)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)


# Montgomery multiplication on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_MONTGOMERY = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_montgomery
$(TEST_ENV_M55_MPS2_FVP_LINK_MONTGOMERY): $(TEST_MONTGOMERY_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_MONTGOMERY_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-montgomery
build-m55-mps2-fvp-montgomery: $(TEST_ENV_M55_MPS2_FVP_LINK_MONTGOMERY)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-montgomery
run-m55-mps2-fvp-montgomery: $(TEST_ENV_M55_MPS2_FVP_LINK_MONTGOMERY)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-montgomery
debug-m55-mps2-fvp-montgomery: $(TEST_ENV_M55_MPS2_FVP_LINK_MONTGOMERY)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# Karatsuba multiplication on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_KARATSUBA = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_karatsuba
$(TEST_ENV_M55_MPS2_FVP_LINK_KARATSUBA): $(TEST_KARATSUBA_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_KARATSUBA_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-karatsuba
build-m55-mps2-fvp-karatsuba: $(TEST_ENV_M55_MPS2_FVP_LINK_KARATSUBA)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-karatsuba
run-m55-mps2-fvp-karatsuba: $(TEST_ENV_M55_MPS2_FVP_LINK_KARATSUBA)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-karatsuba
debug-m55-mps2-fvp-karatsuba: $(TEST_ENV_M55_MPS2_FVP_LINK_KARATSUBA)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# Poly multiplication on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_POLY = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_poly
$(TEST_ENV_M55_MPS2_FVP_LINK_POLY): $(TEST_POLY_SRC_MANUAL_KARATSUBA) $(TEST_POLY_SRC_MANUAL_SCHOOLBOOK) $(TEST_POLY_SRC_MANUAL_MONTGOMERY) $(TEST_POLY_SRC_AUTO_TOOM4) $(TEST_POLY_SRC_AUTO_SCHOOLBOOK) $(TEST_POLY_SRC_AUTO_NTT_N256)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_POLY_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-poly
build-m55-mps2-fvp-poly: $(TEST_ENV_M55_MPS2_FVP_LINK_POLY)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-poly
run-m55-mps2-fvp-poly: $(TEST_ENV_M55_MPS2_FVP_LINK_POLY)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-poly
debug-m55-mps2-fvp-poly: $(TEST_ENV_M55_MPS2_FVP_LINK_POLY)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# Saber on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_SABER = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_saber
$(TEST_ENV_M55_MPS2_FVP_LINK_SABER): $(TEST_SABER_SRC_MANUAL_KARATSUBA) $(TEST_SABER_SRC_MANUAL_MONTGOMERY) $(TEST_SABER_SRC_AUTO_TOOM4) $(TEST_SABER_SRC_AUTO_SCHOOLBOOK) $(TEST_SABER_SRC_AUTO_NTT_N256)
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_SABER_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@


.PHONY: build-m55-mps2-fvp-saber
build-m55-mps2-fvp-saber: $(TEST_ENV_M55_MPS2_FVP_LINK_SABER)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-saber
run-m55-mps2-fvp-saber: $(TEST_ENV_M55_MPS2_FVP_LINK_SABER)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-saber
debug-m55-mps2-fvp-saber: $(TEST_ENV_M55_MPS2_FVP_LINK_SABER)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

# Template on M55-MPS2-FVP

TEST_ENV_M55_MPS2_FVP_LINK_HELLOWORLD = $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_helloworld
$(TEST_ENV_M55_MPS2_FVP_LINK_HELLOWORLD):
	rm -f $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	ln -s ../../../$(TEST_HELLOWORLD_DIR) $(TEST_ENV_M55_MPS2_FVP_SYMLINK)
	rm -f $(TEST_ENV_M55_MPS2_FVP_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) clean
	touch $@

.PHONY: build-m55-mps2-fvp-helloworld
build-m55-mps2-fvp-helloworld: $(TEST_ENV_M55_MPS2_FVP_LINK_HELLOWORLD)
	make -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: run-m55-mps2-fvp-helloworld
run-m55-mps2-fvp-helloworld: $(TEST_ENV_M55_MPS2_FVP_LINK_HELLOWORLD)
	make run -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

.PHONY: debug-m55-mps2-fvp-helloworld
debug-m55-mps2-fvp-helloworld: $(TEST_ENV_M55_MPS2_FVP_LINK_HELLOWORLD)
	make debug -C $(TEST_ENV_M55_MPS2_FVP_BASE) -j$(nproc)

###
### Core test environment
###

# Toom test on M55-CORE

TEST_ENV_M55_CORE_LINK_TOOM = $(TEST_ENV_M55_CORE_BASE)/test_loaded_toom
$(TEST_ENV_M55_CORE_LINK_TOOM): $(TEST_POLY_TOOM_SRC_AUTO)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_POLY_TOOM_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-toom
build-m55-core-toom: $(TEST_ENV_M55_CORE_LINK_TOOM)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# Schoolbook test on M55-CORE

TEST_ENV_M55_CORE_LINK_SCHOOLBOOK = $(TEST_ENV_M55_CORE_BASE)/test_loaded_schoolbook
$(TEST_ENV_M55_CORE_LINK_SCHOOLBOOK): $(TEST_POLY_SCHOOLBOOK_SRC_AUTO)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_POLY_SCHOOLBOOK_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-schoolbook
build-m55-core-schoolbook: $(TEST_ENV_M55_CORE_LINK_SCHOOLBOOK)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# Permute test on M55-CORE

TEST_ENV_M55_CORE_LINK_PERMUTE = $(TEST_ENV_M55_CORE_BASE)/test_loaded_permute
$(TEST_ENV_M55_CORE_LINK_PERMUTE): $(TEST_PERMUTE_SRC_AUTO)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_PERMUTE_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-permute
build-m55-core-permute: $(TEST_ENV_M55_CORE_LINK_PERMUTE)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# Transpose test on M55-CORE

TEST_ENV_M55_CORE_LINK_TRANSPOSE = $(TEST_ENV_M55_CORE_BASE)/test_loaded_transpose
$(TEST_ENV_M55_CORE_LINK_TRANSPOSE): $(TEST_TRANSPOSE_SRC_AUTO)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_TRANSPOSE_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-transpose
build-m55-core-transpose: $(TEST_ENV_M55_CORE_LINK_TRANSPOSE)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# NTT test on M55-CORE

TEST_ENV_M55_CORE_LINK_NTT = $(TEST_ENV_M55_CORE_BASE)/test_loaded_ntt
$(TEST_ENV_M55_CORE_LINK_NTT): $(TEST_NTT_SRC_AUTO)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_NTT_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-ntt
build-m55-core-ntt: $(TEST_ENV_M55_CORE_LINK_NTT)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# Montgomery multiplication on M55-CORE

TEST_ENV_M55_CORE_LINK_MONTGOMERY = $(TEST_ENV_M55_CORE_BASE)/test_loaded_montgomery
$(TEST_ENV_M55_CORE_LINK_MONTGOMERY): $(TEST_MONTGOMERY_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_MONTGOMERY_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-montgomery
build-m55-core-montgomery: $(TEST_ENV_M55_CORE_LINK_MONTGOMERY)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# Karatsuba multiplication on M55-CORE

TEST_ENV_M55_CORE_LINK_KARATSUBA = $(TEST_ENV_M55_CORE_BASE)/test_loaded_karatsuba
$(TEST_ENV_M55_CORE_LINK_KARATSUBA): $(TEST_KARATSUBA_SRC_MANUAL)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_KARATSUBA_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-karatsuba
build-m55-core-karatsuba: $(TEST_ENV_M55_CORE_LINK_KARATSUBA)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# Template on M55-CORE

TEST_ENV_M55_CORE_LINK_HELLOWORLD = $(TEST_ENV_M55_CORE_BASE)/test_loaded_helloworld
$(TEST_ENV_M55_CORE_LINK_HELLOWORLD):
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_HELLOWORLD_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-helloworld
build-m55-core-helloworld: $(TEST_ENV_M55_CORE_LINK_HELLOWORLD)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# Poly multiplication on M55-Core

TEST_ENV_M55_CORE_LINK_POLY = $(TEST_ENV_M55_CORE_BASE)/test_loaded_poly
$(TEST_ENV_M55_CORE_LINK_POLY): $(TEST_POLY_SRC_MANUAL_KARATSUBA) $(TEST_POLY_SRC_MANUAL_SCHOOLBOOK) $(TEST_POLY_SRC_MANUAL_MONTGOMERY) $(TEST_POLY_SRC_AUTO_TOOM4) $(TEST_POLY_SRC_AUTO_SCHOOLBOOK) $(TEST_POLY_SRC_AUTO_NTT)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_POLY_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@

.PHONY: build-m55-core-poly
build-m55-core-poly: $(TEST_ENV_M55_CORE_LINK_POLY)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)

# Saber on M55-Core

TEST_ENV_M55_CORE_LINK_SABER = $(TEST_ENV_M55_CORE_BASE)/test_loaded_saber
$(TEST_ENV_M55_CORE_LINK_SABER): $(TEST_SABER_SRC_MANUAL_KARATSUBA) $(TEST_SABER_SRC_MANUAL_MONTGOMERY) $(TEST_SABER_SRC_AUTO_TOOM4) $(TEST_SABER_SRC_AUTO_SCHOOLBOOK) $(TEST_SABER_SRC_AUTO_NTT)
	rm -f $(TEST_ENV_M55_CORE_SYMLINK)
	ln -s ../../../$(TEST_SABER_DIR) $(TEST_ENV_M55_CORE_SYMLINK)
	rm -f $(TEST_ENV_M55_CORE_BASE)/test_loaded_*
	make -C $(TEST_ENV_M55_CORE_BASE) clean
	touch $@


.PHONY: build-m55-core-saber
build-m55-core-saber: $(TEST_ENV_M55_CORE_LINK_SABER)
	make -C $(TEST_ENV_M55_CORE_BASE) -j$(nproc)
